# generated by datamodel-codegen:
#   filename:  storage.json

from __future__ import annotations

from pydantic import BaseModel
from pydantic import ConfigDict


class Key(BaseModel):
    model_config = ConfigDict(extra='forbid')

    address: str
    nat: str


class LedgerItem(BaseModel):
    model_config = ConfigDict(extra='forbid')

    key: Key
    value: str


class Key1(BaseModel):
    model_config = ConfigDict(extra='forbid')

    address: str
    nat: str


class Value(BaseModel):
    model_config = ConfigDict(extra='forbid')

    allowances: list[str]
    borrow: str
    lastBorrowIndex: str


class Account(BaseModel):
    model_config = ConfigDict(extra='forbid')

    key: Key1
    value: Value


class MainTokenItem(BaseModel):
    model_config = ConfigDict(extra='forbid')

    fA12: str


class FA2(BaseModel):
    model_config = ConfigDict(extra='forbid')

    address: str
    nat: str


class MainTokenItem1(BaseModel):
    model_config = ConfigDict(extra='forbid')

    fA2: FA2


class Tokens(BaseModel):
    model_config = ConfigDict(extra='forbid')

    mainToken: MainTokenItem | MainTokenItem1
    interestRateModel: str
    interestUpdateTime: str
    priceUpdateTime: str
    totalBorrowsF: str
    totalLiquidF: str
    totalSupplyF: str
    totalReservesF: str
    borrowIndex: str
    maxBorrowRate: str
    collateralFactorF: str
    reserveFactorF: str
    lastPrice: str
    borrowPause: bool
    isInterestUpdating: bool
    threshold: str


class TokenMetadata(BaseModel):
    model_config = ConfigDict(extra='forbid')

    token_id: str
    tokens: dict[str, str]


class KeyItem(BaseModel):
    model_config = ConfigDict(extra='forbid')

    fA12: str


class FA21(BaseModel):
    model_config = ConfigDict(extra='forbid')

    address: str
    nat: str


class KeyItem1(BaseModel):
    model_config = ConfigDict(extra='forbid')

    fA2: FA21


class Asset(BaseModel):
    model_config = ConfigDict(extra='forbid')

    key: KeyItem | KeyItem1
    value: str


class Storage(BaseModel):
    model_config = ConfigDict(extra='forbid')

    admin: str
    ledger: list[LedgerItem]
    accounts: list[Account]
    tokens: dict[str, Tokens]
    metadata: dict[str, str]
    tokenMetadata: dict[str, TokenMetadata]
    lastTokenId: str
    priceFeedProxy: str
    closeFactorF: str
    liqIncentiveF: str
    markets: dict[str, list[str]]
    borrows: dict[str, list[str]]
    maxMarkets: str
    assets: list[Asset]


class YupanaStorage(BaseModel):
    model_config = ConfigDict(extra='forbid')

    storage: Storage
    tokenLambdas: dict[str, str]
    useLambdas: dict[str, str]
